import pymysql

from InterfaceAutoTest_V1.common import log
from InterfaceAutoTest_V1.common.read_ini import ReadIni


class DB:
    def __init__(self):
        read_ini = ReadIni()
        try:
            self.conn = pymysql.connect(
                host=read_ini.get_sql_conn_message('host'),
                port=int(read_ini.get_sql_conn_message('port')),
                user=read_ini.get_sql_conn_message('user'),
                password=read_ini.get_sql_conn_message('pwd'),
                database=read_ini.get_sql_conn_message('database'),
                charset="utf8"
            )
            self.cursor = self.conn.cursor()
        except:
            log.error('数据库链接失败或游标对象创建失败,请检查数据库配置！！！')

    def query(self, sql):
        try:
            self.cursor.execute(sql)
            select_result = self.cursor.fetchall()
            if select_result:
                return select_result[0][0]
        except:
            log.error("执行查询的sql语句错误，请察看sql语句是否正确")

    def delete(self, sql):
        try:
            self.cursor.execute(sql)
            self.conn.commit()
        except:
            log.error("执行删除的sql语句错误，请察看sql语句是否正确")

    def update(self, sql):
        pass

    def insert(self, sql):
        pass

    def close(self):
        self.cursor.close()
        self.conn.close()