import configparser
import os

from InterfaceAutoTest_V1.common import log


class ReadIni:
    def __init__(self):
        self.data_config_path = os.path.join(os.path.dirname(os.path.dirname(__file__)), 'data_config')
        ini_path = os.path.join(self.data_config_path, 'config.ini')
        self.conf = configparser.ConfigParser()
        self.conf.read(ini_path, encoding='utf-8')

    def get_file_path(self, key: str):
        try:
            file_path = os.path.join(self.data_config_path, self.conf.get('file', key))
            if os.path.isfile(file_path):
                return file_path
            else:
                log.error('获取的文件路径非法!!!')
        except:
            log.error('传入的%s非法,请检查是否与config文件中file节点下的key值对应' % (key))

    def get_host_value(self, key: str):
        try:
            value = self.conf.get('host', key)
        except:
            log.error('传入的%s非法,请检查是否与config文件中host节点下的key值对应' % (key))
        else:
            return value

    def get_table_name(self, key: str):
        try:
            value = self.conf.get('table', key)
        except:
            log.error('传入的%s非法,请检查是否与config文件中table节点下的key值对应' % (key))
        else:
            return value

    def get_sql_conn_message(self, key: str):
        try:
            value = self.conf.get('sql', key)
        except:
            log.error('传入的%s非法,请检查是否与config文件中sql节点下的key值对应' % (key))
        else:
            return value
