import base64

import requests

from InterfaceAutoTest_V1.common import log
from InterfaceAutoTest_V1.common.read_ini import ReadIni


class RequestsAll:
    def __init__(self):
        login_url = ReadIni().get_host_value('host') + '/auth'
        login_data = {'username': 'admin', 'password': base64.b64encode("123456".encode()).decode()}
        self.bpm_session = requests.Session()
        self.bpm_session.headers.update(
            {"Authorization": "Bearer " + self.bpm_session.post(url=login_url, json=login_data).json().get("token")})

    def requests_all(self, req_method, req_url, req_mime=None, case_data=None):
        if req_mime == "json" or req_mime == "application/json":
            return self.bpm_session.request(method=req_method, url=req_url, json=case_data)
        elif req_mime == "x-www-form-urlencoded" or req_mime == "application/x-www-form-urlencoded":
            return self.bpm_session.request(method=req_method, url=req_url, data=case_data)
        elif req_mime == "form-data" or req_mime == "multipart/form-data":
            return self.bpm_session.request(method=req_method, url=req_url, files=case_data)
        elif req_mime == "query" or req_mime == "params" or req_mime == "param":
            return self.bpm_session.request(method=req_method, url=req_url, params=case_data)
        elif req_mime is None:
            return self.bpm_session.request(method=req_method, url=req_url)
        elif req_mime == "query|body" or req_mime == "body|query" or req_mime == "json|query" or req_mime == "query|json":
            return self.bpm_session.request(method=req_method, url=req_url, params=case_data["query"],
                                            json=case_data["body"])
        else:
            log.error("传入的媒体类型的值错误,请检查excel中是否填入正确")
