import allure
import pytest

from InterfaceAutoTest_V1.common import log
from InterfaceAutoTest_V1.common.read_excel import ReadExcel


class TestBpm:
    @allure.epic('BPM系统测试-王德发')
    @pytest.mark.parametrize(
        'module_name,api_name,case_title,case_level,case_url, case_method, case_mime,  case_data, expect_data,'
        ' sql_type,sql_data, update_key',
        ReadExcel('BPM-WDF').get_data())
    def test_bpm(self, db_fix, req_fix, module_name, api_name, case_title, case_level, case_url, case_method, case_mime,
                 case_data, expect_data, sql_type,
                 sql_data, update_key):
        allure.dynamic.feature(module_name)
        allure.dynamic.story(api_name)
        allure.dynamic.title(case_title)
        allure.dynamic.severity(case_level)
        if sql_type == 'delete':
            db_fix.delete(sql_data)
        elif sql_type == 'select':
            case_data[update_key] = db_fix.query(sql_data)
        elif sql_type == 'select|delete' or sql_type == 'delete|select':
            db_fix.delete(sql_data['delete'])
            case_data[update_key] = db_fix.query(sql_data['select'])
        res = req_fix.requests_all(req_method=case_method, req_url=case_url, req_mime=case_mime, case_data=case_data)

        try:
            for key in expect_data:
                assert expect_data[key] == res.json()[key]
            print('断言成功!!!')
        except:
            log.error("断言失败" + "，用例数据为：" + str(case_data) + ",期望数据为：" + str(
                expect_data) + ",服务器返回的数据为：" + res.text)
            raise AssertionError('断言失败!!!')


if __name__ == '__main__':
    pytest.main()
